package bobmaccallum;

import simplerace.Controller;
import simplerace.SensorModel;
import simplerace.Vector2d;

public class PerlGPSolo02Controller implements Controller {

    public void reset() {}

    public int control (SensorModel inputs) {
      Vector2d v1 = inputs.getVelocity();
    Vector2d v2 = inputs.getNextNextWaypointPosition();
    v1.mul(inputs.getAngularVelocity());
    v2.limit(0.3427);
    double drive = (Math.abs(((v2.sqMag() - (inputs.getAngleToNextWaypoint() * inputs.getDistanceToNextWaypoint() * inputs.getAngleToNextWaypoint() / v1.sqMag())) / 3.6375)) - 0.3600) * -3.9035;
    double steer = (inputs.getAngleToNextWaypoint() * (-4.9805 * inputs.getSpeed() / inputs.getDistanceToNextWaypoint()) > 0 ? -0.1230 : v2.sqMag());
    double dthresh = Math.abs(((inputs.getAngularVelocity() / inputs.getDistanceToNextWaypoint()) / -1.9850));
    double sthresh = Math.abs(inputs.getAngularVelocity());

      int driving = drive < -dthresh ? 0 : (drive > dthresh ? 2 : 1);
      int steering = steer < -sthresh ? 0 : (steer > sthresh ? 2 : 1);
      return driving * 3 + steering;
    }
}
